//+------------------------------------------------------------------+
//|                                                  LeManSystem.mq5 |
//|                                         Copyright  2009, LeMan. |
//|                                                 b-market@mail.ru |
//+------------------------------------------------------------------+
//----  
#property copyright "Copyright  2009, LeMan."
//----    
#property link      "b-market@mail.ru"
//----   
#property version   "1.00"
#property description ""
//----   
#property version   "1.10"
//----     
#property indicator_chart_window 
//----        
#property indicator_buffers 4
//----     
#property indicator_plots   4
//+----------------------------------------------+
//|                  |
//+----------------------------------------------+
//----   1   
#property indicator_type1   DRAW_LINE
//----      LimeGreen 
#property indicator_color1  LimeGreen
//----   1  1
#property indicator_width1  1
//----    
#property indicator_label1  "Lower LeMan"
//+----------------------------------------------+
//|                  |
//+----------------------------------------------+
//----   2   
#property indicator_type2   DRAW_LINE
//----      DeepPink 
#property indicator_color2  DeepPink
//----   2  1
#property indicator_width2  1
//----    
#property indicator_label2 "Upper LeMan"
//+----------------------------------------------+
//|                  |
//+----------------------------------------------+
//----   3   
#property indicator_type3   DRAW_ARROW
//----      DeepPink 
#property indicator_color3  clrDeepPink
//----   3  2
#property indicator_width3  2
//----    
#property indicator_label3  "LeManStop Sell"
//+----------------------------------------------+
//|                  |
//+----------------------------------------------+
//----   4   
#property indicator_type4   DRAW_ARROW
//----      LimeGreen 
#property indicator_color4  clrLimeGreen
//----   4  2
#property indicator_width4  2
//----    
#property indicator_label4 "LeManStop Buy"
//+----------------------------------------------+
//|                            |
//+----------------------------------------------+
#define RESET 0 //        

//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input uint period=12;
input int Shift=0; //     
//+----------------------------------------------+
//----   ,    
//      
double BuyBuffer[],SellBuffer[];
double UpBuffer[],DnBuffer[];
//----      
int  min_rates_total;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
  {
//----      
   min_rates_total=int(period+3);

//----      
   SetIndexBuffer(0,UpBuffer,INDICATOR_DATA);
//----       1
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----       
   ArraySetAsSeries(UpBuffer,true);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0);

//----      
   SetIndexBuffer(1,DnBuffer,INDICATOR_DATA);
//----       2
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//----       
   ArraySetAsSeries(DnBuffer,true);
//----   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,0);

//----      
   SetIndexBuffer(2,SellBuffer,INDICATOR_DATA);
//----       3
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,min_rates_total);
//----   
   PlotIndexSetInteger(2,PLOT_ARROW,159);
//----       
   ArraySetAsSeries(SellBuffer,true);
//----   ,      
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,0);

//----      
   SetIndexBuffer(3,BuyBuffer,INDICATOR_DATA);
//----       4
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,min_rates_total);
//----   
   PlotIndexSetInteger(3,PLOT_ARROW,159);
//----       
   ArraySetAsSeries(BuyBuffer,true);
//----   ,      
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,0);

//----     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//----         
   IndicatorSetString(INDICATOR_SHORTNAME,"LeManStop");
//----   
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
                )
  {
//----       
   if(rates_total<min_rates_total) return(RESET);

//----    
   int limit,bar;
   double HL1,HL2,LH1,LH2;

//----         
   ArraySetAsSeries(high,true);
   ArraySetAsSeries(low,true);

//----    limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
     {
      limit=rates_total-min_rates_total-1; //      
     }
   else limit=rates_total-prev_calculated; //      

//----    
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      BuyBuffer[bar]=0.0;
      SellBuffer[bar]=0.0;
      
      HL1=low[ArrayMaximum(low,bar+1,period)];
      HL2=low[ArrayMaximum(low,bar+2,period)];
      
      LH1=high[ArrayMinimum(high,bar+1,period)];
      LH2=high[ArrayMinimum(high,bar+2,period)];
      
      if (low[bar+2] <= LH2 && low[bar+1] > LH1) BuyBuffer[bar] = high[bar+1]+_Point;
      if (high[bar+2] >= HL2 && high[bar+1] < HL1) SellBuffer[bar] = low[bar+1]-_Point;
      
      DnBuffer[bar]=low[ArrayMinimum(low,bar+1,period)];
      UpBuffer[bar]=high[ArrayMaximum(high,bar+1,period)];
      
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
